PrototypeR4::Application.routes.draw do

  devise_for :users
  
  # routes for sinatra app
  match '/site/set_registered', :to => CentralServerExchangeApp  
  match '/site/public_key', :to => CentralServerExchangeApp 
  match '/site/update', :to => GithubApp
  match '/purchase/design', :to => CentralServerExchangeApp
  
  # routes for admin
  namespace :admin do
    resources :assets
    resources :designs do
      get 'upload_package' ,:on => :collection
      post 'upload_package' ,:on => :collection
      member do
        post 'edit_file'  => 'designs#edit_file'
      end
    end
    resources :items
    resources :links do
      member do
        get 'delete'
      end
    end
    resources :pages do
      member do
        get 'delete'
      end
    end
    resources :page_parts
    resources :purchases do
      member do
        get 'download'
      end
    end
    resources :sites
    resources :snippets
    resources :translations
    resources :user_info_models
    resources :user_role_models
  end
  # end admin
  
  namespace :panel do
    resources :users
  end
  
  # routes for gridfs files
  match "/gridfs/*path" => "gridfs#serve"

  # routes for pages to generate
  match '*page_name' => 'pages#show', :as => :page, :constraints => lambda{|request|
    !request.path.starts_with?("/panel")
  }
  
  root :to => 'pages#index'
  
end
